/* program to convert a triangle list to an edge list */

#include <stdio.h>


main(argc,argv)

int argc;
char *argv[];

{

  FILE *in,*out;
  double trngl[9]; 
  int total;

  if(argc < 3) {
    Usage(); exit(0);
   }

  if(strcmp(argv[1],"-") == 0)  in = stdin;
  else in = fopen(argv[1],"r");
  if(in == NULL) {
    fprintf(stderr,"Cannot open input file %s\n",argv[1]);
    exit(0);
   }

  if(strcmp(argv[2],"-") == 0)  out = stdout;
  else  out = fopen(argv[2],"w");
  if(out == NULL) {
    fprintf(stderr,"Cannot open output file %s\n",argv[2]);
    exit(0);
   }

  total = 0;
  while(1) {
     if(fscanf(in,"%lf %lf %lf",trngl,trngl+1,trngl+2) != 3) {
        break;
       }
     if(fscanf(in,"%lf %lf %lf",trngl+3,trngl+4,trngl+5) != 3) {
        break;
       }
     if(fscanf(in,"%lf %lf %lf",trngl+6,trngl+7,trngl+8) != 3) {
        break;
       }

     fprintf(out,"%.3lf %.3lf %.3lf   %.3lf %.3lf %.3lf\n",
                   trngl[0],trngl[1],trngl[2],
                   trngl[3],trngl[4],trngl[5]);
     fprintf(out,"%.3lf %.3lf %.3lf   %.3lf %.3lf %.3lf\n",
                   trngl[3],trngl[4],trngl[5],
                   trngl[6],trngl[7],trngl[8]);
     fprintf(out,"%.3lf %.3lf %.3lf   %.3lf %.3lf %.3lf\n",
                   trngl[6],trngl[7],trngl[8],
                   trngl[0],trngl[1],trngl[2]);
     total++; 
    }
  fprintf(stderr,"Total of %d triangles processed.\n",total);
}

Usage()
{
  fprintf(stderr,"Usage: tri2edge infile outfile\n"); 
  fprintf(stderr,"  if infile = '-' then stdin is used.\n");
  fprintf(stderr,"  if outfile = '-' then stdout is used.\n");
}


